﻿
namespace mmd2timeline.Player
{
    internal partial class Player
    {
        /// <summary>
        /// 设置所有人物的关节配置
        /// </summary>
        internal void SetAllPersonJoints()
        {
            var motionControllers = this.PersonMotionControllers.Values.ToList();

            foreach (var motionController in motionControllers)
            {
                motionController.SetPersonAllJoints();
            }
        }

        /// <summary>
        /// 设置所有人物的关节弹簧比例
        /// </summary>
        internal void SetAllPersonJointsSpringPercent()
        {
            var motionControllers = this.PersonMotionControllers.Values.ToList();

            foreach (var motionController in motionControllers)
            {
                motionController.SetPersonAllJointsSpringPercent();
            }
        }

        /// <summary>
        /// 设置所有人物的关节阻尼比例
        /// </summary>
        internal void SetAllPersonJointsDamperPercent()
        {
            var motionControllers = this.PersonMotionControllers.Values.ToList();

            foreach (var motionController in motionControllers)
            {
                motionController.SetPersonAllJointsDamperPercent();
            }
        }

        /// <summary>
        /// 设置所有人物的关节最大速度
        /// </summary>
        internal void SetAllPersonJointsMaxVelocity()
        {
            var motionControllers = this.PersonMotionControllers.Values.ToList();

            foreach (var motionController in motionControllers)
            {
                motionController.SetPersonAllJointsMaxVelocity();
            }
        }
    }
}
