﻿using mmd2timeline.Player.Model;
using MacGruber;
using System;
using System.Collections;
using UnityEngine;

namespace mmd2timeline.Player
{
    internal partial class Settings : MVRScript
    {
        public const string PLUGIN_NAME = "MMD2Timeline";

        public const string VERSION = "1.0.0a";

        /// <summary>
        /// 获取插件的版本号
        /// </summary>
        protected virtual string Version
        {
            get
            {
                return VERSION;
            }
        }

        /// <summary>
        /// 默认配置
        /// </summary>
        protected static readonly Config dft = Config.GetDefault();
        /// <summary>
        /// 配置
        /// </summary>
        protected static readonly Config config = Config.GetInstance();
        /// <summary>
        /// 语言
        /// </summary>
        protected static readonly Lang lang = Lang.GetInstance();

        public override void InitUI()
        {
            //if (LibMMD.Util.Settings.varPmxPath == null && this.name.IndexOf('_') > 0)
            //{
            //    LibMMD.Util.Settings.varPmxPath = MacGruber.Utils.GetPluginPath(this) + "/g2f.pmx";
            //    LogUtil.Debug("pmx path:" + LibMMD.Util.Settings.varPmxPath);
            //}

            base.InitUI();
            InitFullWidthUI();
        }

        ///// <summary>
        ///// 在后台运行
        ///// </summary>
        ///// <param name="action"></param>
        //protected void RunInBackground(ThreadStart action)
        //{
        //    Thread loadThread = new Thread(action);
        //    loadThread.IsBackground = true;
        //    loadThread.Start();
        //}

        /// <summary>
        /// 等待n秒后执行方法
        /// </summary>
        /// <param name="s"></param>
        /// <param name="action"></param>
        /// <returns></returns>
        protected static IEnumerator WaitForSecondsRealtime(float s, Action action = null)
        {
            yield return new WaitForSecondsRealtime(s);
            action?.Invoke();
        }

        /// <summary>
        /// 当启用时执行的方法
        /// </summary>
        public virtual void OnEnable()
        {

        }

        /// <summary>
        /// 当禁用时执行的方法
        /// </summary>
        public virtual void OnDisable()
        {

        }

        /// <summary>
        /// 当销毁时调用的方法
        /// </summary>
        public virtual void OnDestroy()
        {
            Utils.OnDestroyUI(this);
        }
    }
}
